# Contribution Guide
## Actively participate in the development and the future of Inkline by contributing regularly. { .lead }

Open Source projects are maintained and backed by a **wonderful community** of users and collaborators.

We encourage you to actively participate in the development and future of Inkline by contributing to the source code, improving documentation, reporting potential bugs or testing new features.

### Channels

There are many ways to taking part in the Inkline community.

1. <a href="https://github.com/inkline/inkline" rel="nofollow" target="_blank">Github Repositories</a>: Report bugs or create feature requests against the dedicated Inkline repository.
2. <a href="https://discord.gg/2w5UGnK" rel="nofollow" target="_blank">Discord</a>: Join the Discord Server to chat instantly with other developers in the Inkline community.
3. <a href="https://twitter.com/inkline" rel="nofollow" target="_blank">Twitter</a>: Stay in touch with the progress we make and learn about the awesome things happening around Inkline.

### Bug Reports

A bug is a _demonstrable problem_ that is caused by the code in the repository.
Good bug reports are extremely helpful, so thanks!

Guidelines for bug reports:

1. Provide a clear title and description of the issue.
2. Share the version of Inkline you are using.
3. Add code examples to demonstrate the issue. You can also provide a complete repository to reproduce the issue quickly.

A good bug report shouldn't leave others needing to chase you up for more information. Please try to be as detailed as possible in your report:

- What is your environment? 
- What steps will reproduce the issue? 
- What browser(s) and OS experience the problem? 
- Do other browsers show the bug differently? 
- What would you expect to be the outcome? 

All these details will help us fix any potential bugs. Remember, fixing bugs takes time. We're doing our best!

<a href="https://github.com/inkline/inkline/issues/new" rel="nofollow" target="_blank">Create a bug report</a>

## Feature requests
Feature requests are welcome! When opening a feature request, it's up to *you* to make a strong case to convince the project's developers of the merits of this feature. Please provide as much detail and context as possible.

When adding a new feature to the framework, make sure you update the documentation package as well.

### Testing
Before providing a pull request be sure to test the feature you are adding. Inkline's target code coverage is 100% and we're proudly consistent with that.

<a href="https://coveralls.io/github/inkline/inkline?branch=master" rel="nofollow">
    <img src="https://coveralls.io/repos/github/inkline/inkline/badge.svg?branch=master" alt="Coverage Status" data-canonical-src="https://coveralls.io/repos/github/inkline/inkline/badge.svg?branch=master" style="max-width:100%;">
</a>

## License
By contributing your code, you agree to license your contribution under the <a href="https://github.com/inkline/inkline/blob/master/packages/inkline/LICENSE" rel="nofollow" target="_blank">MIT License</a>.
By contributing to the documentation, you agree to license your contribution under the <a href="https://github.com/inkline/inkline/blob/master/packages/docs/LICENSE" rel="nofollow" target="_blank">Creative Commons Attribution 3.0 Unported License</a>.
